package cgl.ogc.wms.client.google;

import java.io.*;
import java.net.*;
import java.rmi.*;
import java.util.*;

import javax.activation.*;
import javax.xml.rpc.*;

import cgl.ogc.wms.requests.getFeatureInfo.*;
import cgl.ogc.wms.requests.getMap.*;
import cgl.ogc.wms.requests.getMap.BoundingBox;
import cgl.ogc.wms.requests.getMap.Description;
import cgl.ogc.wms.requests.getMap.Map;
import cgl.ogc.wms.requests.getMap.NamedLayer;
import cgl.ogc.wms.requests.getMap.StyledLayerDescriptor;
import cgl.ogc.wms.requests.getMap.StyledLayerDescriptorChoice;
import cgl.ogc.wms.requests.getMap.StyledLayerDescriptorChoiceItem;
import cgl.ogc.wms.requests.getMap.types.*;
import org.apache.axis.attachments.*;
import org.exolab.castor.xml.*;
import org.exolab.castor.xml.MarshalException;

/**
 *
 * <p>Title: Client code to interact OGC WMS </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Ahmet Sayar
 * @version 1.0
 */
public class WMSClient {

    private String wmsname;
    private String applpath;

    /**
     *
     */
    public void WMSClient() {
    }

    /**
     *
     * @param proppath String
     * @param applpat String
     */
    public void setWMSname(String proppath, String applpat) {
        System.out.println("proppath=" + proppath);
        try {
            Properties prp = new Properties();
            prp.load(new FileInputStream(new File(proppath)));
            wmsname = prp.getProperty("WMSNAME");
            applpath = applpat;

            System.out.println("applpath=" + applpath);
            System.out.println("wmsname=" + wmsname);

        } catch (IOException ex) {
            System.out.println("IOExceprion...............");
        }

    }

    /**
     *
     * @param args String[]
     */
    public static void main(String args[]) {
        WMSClient wc = new WMSClient();

        String bbox = "-124.85,32.26,-113.56,42.75";
        String heigth = "300";
        String width = "400";
        Vector layers = new Vector();
        layers.add("World:Base");

        String req = wc.createGetMapRequest(bbox, heigth, width, layers);
        System.out.println("request : " + req);

        try {
            byte[] mapbytes = wc.getMap(req);
            if (mapbytes != null && mapbytes.length > 0) {
                OutputStream os = new FileOutputStream(
                        "C:/jbproject/googlemap/googlemap/images/mymap.jpg");
                os.write(mapbytes);
            }
        } catch (Exception ex) {
            System.out.println("exception ............");
            ex.printStackTrace();
        }

    }

    /**
     *
     * @param bbox_ String
     * @param mimetype String
     * @param pointx String
     * @param pointy String
     * @param heigth String
     * @param width String
     * @param slayers Vector
     * @return String
     */
    public String createGetFeatureInfoRequest(String bbox_, String mimetype,
                                              String pointx, String pointy,
                                              String heigth, String width,
                                              Vector slayers) {

        String request = null;
        String querylayers = "";
        String concat = ",";

        cgl.ogc.wms.requests.getFeatureInfo.Map m = new cgl.ogc.wms.requests.
                getFeatureInfo.Map();
        cgl.ogc.wms.requests.getFeatureInfo.BoundingBox bbox = new cgl.ogc.wms.
                requests.getFeatureInfo.BoundingBox();
        bbox.setContent(bbox_);
        m.setBoundingBox(bbox);

        cgl.ogc.wms.requests.getFeatureInfo.Image img = new cgl.ogc.wms.
                requests.getFeatureInfo.Image();
        img.setHeight(Integer.parseInt(heigth));
        img.setWidth(Integer.parseInt(width));
        img.setFormat("image/jpg");
        img.setTransparent(true);
        img.setBGColor("0xFFFFFF");

        GetFeatureInfo gfi = new GetFeatureInfo();
        gfi.setFeatureCount(999);
        if (mimetype == null) {
            gfi.setInfoFormat("text/html");
        } else {
            gfi.setInfoFormat(mimetype);
        }

//    Vector slayers = mid.getSelectedlayers();

        for (int i = 0; i < slayers.size(); i++) {
            if (i == slayers.size() - 1) {
                concat = "";
            }
            querylayers = querylayers + slayers.elementAt(i).toString() +
                          concat;
        }

        gfi.setQueryLayer(querylayers);

//    gfi.setX(mid.getMouseX());
//    gfi.setY(mid.getMouseY());

        gfi.setX(Integer.parseInt(pointx));
        gfi.setY(Integer.parseInt(pointy));

        gfi.setImage(img);
        gfi.setMap(m);

        try {
            StringWriter str = new StringWriter();
            gfi.marshal(str);
            request = str.toString();
        } catch (ValidationException ex) {
            return request;
        } catch (MarshalException ex) {
            return request;
        }

        return request;

    }

    /**
     *
     * @param request String
     * @return String
     */
    public String GetFeatureInfo(String request) {

        cgl.ogc.wms.services.WMSServicesSoapBindingStub binding;

        System.out.println("wmsname : " + wmsname);

        try {
            binding = (cgl.ogc.wms.services.WMSServicesSoapBindingStub)
                      new cgl.ogc.wms.services.WMSServicesServiceLocator().
                      getWMSServices(new URL(wmsname));
            // Time out after a minute
            binding.setTimeout(60000);

            // Test operation
            java.lang.String value = null;
            try {
                value = binding.getFeatureInfo(request);
            } catch (RemoteException ex) {
            }
            // TBD - validate results

            return value;

        } catch (MalformedURLException ex1) {
            return null;
        } catch (ServiceException ex1) {
            return null;
        }

        /*
            WMSServices binding;
            String value = null;
            try {
              binding = new WMSServicesServiceLocator().getWMSServices(new
                  URL(service_address));

              value = binding.getFeatureInfo(request);

              Debug.debugMethodEnd();

              return value;
            }
            catch (Exception ex) {
              ex.printStackTrace();
              return null;
            }
         */
    }


    /**
     *
     * @param bbox_ String
     * @param heigth String
     * @param width String
     * @param layers Vector
     * @return String
     */
    public String createGetMapRequest(String bbox_, String heigth, String width,
                                      Vector layers) {

        System.out.println("bbox_ : " + bbox_);
        System.out.println("heigth : " + heigth);

        System.out.println("width : " + width);
        System.out.println("layers : " + layers.elementAt(0));

        String request = null;
        Map m = new Map();
        BoundingBox bbox = new BoundingBox();
        bbox.setContent(bbox_);
        m.setBoundingBox(bbox);

        cgl.ogc.wms.requests.getMap.Image img = new cgl.ogc.wms.requests.getMap.
                                                Image();
        img.setHeight(Integer.parseInt(heigth));
        img.setWidth(Integer.parseInt(width));
        img.setFormat("image/jpg"); //"image/jpg"
        img.setTransparent(true);
        img.setBGColor("0xFFFFFF");

        StyledLayerDescriptor sld = new StyledLayerDescriptor();

        Vector layerscl = (Vector) layers.clone();

        String layername = null;
        Description desc = new Description();
        NamedLayer nl = new NamedLayer();
        StyledLayerDescriptorChoiceItem sldci = new
                                                StyledLayerDescriptorChoiceItem();
        StyledLayerDescriptorChoice sldc = new StyledLayerDescriptorChoice();

        for (int i = 0; i < layerscl.size(); i++) {
            layername = layerscl.elementAt(i).toString();
            desc = new Description();
            nl = new NamedLayer();
            sldci = new StyledLayerDescriptorChoiceItem();
            sldc = new StyledLayerDescriptorChoice();

            desc.setTitle(layername);
            desc.setAbstract(layername);

            nl.setDescription(desc);
            nl.setName(layername);

            sldci.setNamedLayer(nl);
            sldc.setStyledLayerDescriptorChoiceItem(sldci);
            sld.addStyledLayerDescriptorChoice(i, sldc);
        }

        sld.setVersion(VersionType.valueOf("1.0.20"));

        GetMap gmt = new GetMap();
        gmt.setMap(m);
        gmt.setImage(img);
        gmt.setStyledLayerDescriptor(sld);

        try {
            StringWriter str = new StringWriter();
            gmt.marshal(str);
            request = str.toString();
        } catch (ValidationException ex) {
            return request;
        } catch (MarshalException ex) {
            return request;
        }

//        System.out.println("REQUEST : \n" + request);

        return request;
    }

    /**
     *
     * @param request String
     * @return byte[]
     * @throws Exception
     */
    public byte[] getMap(String request) throws Exception {

        System.out.println("request \n" + request);

        cgl.ogc.wms.services.WMSServicesSoapBindingStub binding;
        try {
            binding = (cgl.ogc.wms.services.WMSServicesSoapBindingStub)
                      new cgl.ogc.wms.services.WMSServicesServiceLocator().
                      getWMSServices(new URL(wmsname));
        } catch (javax.xml.rpc.ServiceException jre) {
            if (jre.getLinkedCause() != null) {
                jre.getLinkedCause().printStackTrace();
            }
            throw new junit.framework.AssertionFailedError(
                    "JAX-RPC ServiceException caught: " + jre);
        }

        // Time out after a minute
        binding.setTimeout(60000);

        // Test operation
        java.lang.Object value = null;
        value = binding.getMap(request);
        // TBD - validate results

        byte[] bs = null;
        Object[] attachments = binding.getAttachments();

        for (int i = 0; i < attachments.length; i++) {
            AttachmentPart att = (AttachmentPart) attachments[i];
            DataHandler dh = att.getActivationDataHandler();
//                 FileOutputStream fos = new FileOutputStream("C:/temp/test.jpg");
            BufferedInputStream bis = new BufferedInputStream(dh.getInputStream());

            bs = new byte[bis.available()];
            bis.read(bs, 0, bs.length);
//                 fos.write(bs);
            bis.close();
//                 fos.close();
        }

        return bs;
//    WMSServicesSoapBindingStub binding;
//    java.lang.Object value = null;
//
//    try {
//      binding = (WMSServicesSoapBindingStub)
//          new WMSServicesServiceLocator().getWMSServices(new
//          URL("http://localhost:8080/wms/services/WMSServices"));
//      binding.setTimeout(999999999);
//
//      value = binding.getMap(request);
//
//    }
//    catch (javax.xml.rpc.ServiceException jre) {
//      if (jre.getLinkedCause() != null) {
//        jre.getLinkedCause().printStackTrace();
//      }
//    }

//
//        if (value != null) {
//            org.apache.axis.attachments.AttachmentPart attachment = new org.
//                    apache.
//                    axis.attachments.AttachmentPart();
//            attachment = (org.apache.axis.attachments.AttachmentPart) value;
//
//            InputStream is = attachment.getDataHandler().getInputStream();
//
//            byte[] bytes = new byte[80000];
//
//            int offset = 0;
//            int numRead = 0;
//            while (offset < bytes.length
//                   &&
//                   (numRead = is.read(bytes, offset, bytes.length - offset)) >=
//                              0) {
//                offset += numRead;
//            }
//
//            is.close();
//
//            return bytes;
//        } else {
//            return null;
//        }
    }


    /**
     *
     * @param bbox String
     */
    public String setBboxJS(String bbox) {

        StringTokenizer st = new StringTokenizer(bbox, " ");
        String tbbox = "";

        String first = st.nextToken();
        String second = st.nextToken();

        StringTokenizer st1 = new StringTokenizer(first, ",");
        StringTokenizer st2 = new StringTokenizer(second, ",");

        String minx_ = st1.nextToken();
        String miny_ = st1.nextToken();
        String maxx_ = st2.nextToken();
        String maxy_ = st2.nextToken();

        double minx = Double.parseDouble(minx_);
        double miny = Double.parseDouble(miny_);
        double maxx = Double.parseDouble(maxx_);
        double maxy = Double.parseDouble(maxy_);

        if (minx < -180.00) {
            minx_ = "-180.00";
        }
        if (miny < -90.00) {
            miny_ = "-90.00";
        }
        if (maxx > 180.00) {
            maxx_ = "180.00";
        }
        if (maxy > 90.00) {
            maxy_ = "90.00";
        }

        tbbox = minx_ + "," + miny_ + "," + maxx_ + "," + maxy_;

        return tbbox;

    }


}
