function GoogleOGCMap(){}

GoogleOGCMap.prototype.initialize=function(a){
  var photo=a.ownerDocument.createElement('img');

  this.setAttributes(photo);
  a.div.appendChild(photo);

  this.setOnce(a);
  this.reZoom(a);

  GEvent.bind(a,"zoom",this,function(){this.reZoom(a)});
  GEvent.addListener(map, 'zoom', function(overlay, point) {
    var latLngStr =  point.x + ',' + point.y ;
    document.getElementById("message_bbox").value = latLngStr;
    zommOgcTasks();
  });

  GEvent.bind(a,"moveend",this,function(){this.reZoom(a)});
  GEvent.addListener(map, 'moveend', function(overlay, point) {
    moveendOgcTasks();
  });

  GEvent.addListener(map, 'click', function(overlay, point) {
    var latLngStr =  point.x + ',' + point.y ;
    document.getElementById("message_bbox").value = latLngStr;
    document.getElementById("pointvalue").value = latLngStr;

    zommOgcTasks();
  });
}

function moveendOgcTasks(){
     document.test.center.value=document.getElementById("message_center").innerHTML;
       document.test.zlevel.value=document.getElementById("message_zlevel").innerHTML;
       document.test.bbox.value=document.getElementById("message_bbox").innerHTML;
       loadmap();
       document.forms[0].submit();
   }

function zommOgcTasks(){
     document.test.center.value=document.getElementById("message_center").innerHTML;
       document.test.zlevel.value=document.getElementById("message_zlevel").innerHTML;
       document.test.bbox.value=document.getElementById("message_bbox").innerHTML;
       document.test.mousex_.value = window.event.clientX;
       document.test.mousey_.value = window.event.clientY;
       loadmap();
       document.forms[0].submit();
   }


GoogleOGCMap.prototype.setAttributes=function(a){
  a.setAttribute('id',this.id);
  a.setAttribute('src',this.src);
  if(this.size){
    var b=this.size;
    a.setAttribute('width',b.width);
    a.setAttribute('height',b.height);
  }
}

GoogleOGCMap.prototype.setOnce=function(a){
  var b=document.getElementById(this.id);
  b.style.position='absolute';
  b.style.zIndex=1;
  if(this.percentOpacity){
    this.setOpacity(this.percentOpacity);
  }
}

GoogleOGCMap.prototype.reZoom=function(a){
  if(this.anchorTopLeft&&this.anchorBottomRight){
    this.autoScaleAndPos(a);
  }else{
    var z=a.getZoomLevel();

    var b=(this.baseZoom?this.baseZoom:0);
    var m=1/Math.pow(2,z-b);
    var c=this.size;
     zw=Math.floor(c.width*m);
    var zh=Math.floor(c.height*m);
    var x=document.getElementById(this.id);
    x.style.width=zw+'px';
    x.style.height=zh+'px';
  }
}

GoogleOGCMap.prototype.autoScaleAndPos=function(a){
  var b=this.anchorTopLeft;
  var c=this.anchorBottomRight;
  var z=a.getZoomLevel();
  var d=this.getXY(a,b,z);
  var e=this.getXY(a,c,z);
  var x=document.getElementById(this.id);
  x.style.top=d.y+'px';
  x.style.left=d.x+'px';
  x.style.width=e.x-d.x+'px';
  x.style.height=e.y-d.y+'px';

  var center = a.getCenterLatLng();
  var latLngStr = center.y + ', ' + center.x ;

  document.getElementById("message_center").innerHTML = latLngStr;

  document.getElementById("message_zlevel").innerHTML = z;

  var bounds = a.getBoundsLatLng();
  latLngStr =  bounds.minX + ',' + bounds.minY + ' ' + bounds.maxX + ',' + bounds.maxY ;
  document.getElementById("message_bbox").innerHTML = latLngStr;

}


GoogleOGCMap.prototype.getXY=function(a,b,c){
  var e=a.spec.getBitmapCoordinate(b.y,b.x,c);
  return a.getDivCoordinate(e.x,e.y);
}

GoogleOGCMap.prototype.setOpacity=function(b){
  if(b<0){b=0;}  if(b>=100){b=100;}
  var c=b/100;
  var d=document.getElementById(this.id);
  if(typeof(d.style.filter)=='string'){d.style.filter='alpha(opacity:'+b+')';}
  if(typeof(d.style.KHTMLOpacity)=='string'){d.style.KHTMLOpacity=c;}
  if(typeof(d.style.MozOpacity)=='string'){d.style.MozOpacity=c;}
  if(typeof(d.style.opacity)=='string'){d.style.opacity=c;}
}

GMap.prototype.addGoogleOGCMap=function(a){
  a.initialize(this);
}

//----------------   load map image
      var progressEnd = 12; // set to number of progress <span>'s.
      var progressColor = 'white';
      var progressInterval = 1000;

      var progressAt = progressEnd;
      var progressTimer;

      function loadmap() {
        document.getElementById("loading").innerHTML = "Loading !";
        document.getElementById("loading").style.visibility = 'visible';
        document.getElementById("preload").style.visibility = 'visible';

        progressAt++;
	if (progressAt > progressEnd)
		progress_clear();
	else
		document.getElementById('progress'+progressAt).style.backgroundColor = progressColor;

	progressTimer = setTimeout('loadmap()',progressInterval);
      }

      function progress_clear() {
        document.getElementById("loading").style.visibility = 'hidden';
        document.getElementById("preload").style.visibility = 'hidden';
      	for (var i = 1; i <= progressEnd; i++) {
		document.getElementById('progress'+i).style.backgroundColor = 'transparent';
      	}
        progressAt = 0;
      }

      function progress_stop() {
        document.getElementById("loading").style.visibility = 'hidden';
        document.getElementById("preload").style.visibility = 'hidden';
	clearTimeout(progressTimer);
	progress_clear();
      }
//-----------------------------------\

